#ifndef DATATYPECONFIGRATION_H
#define DATATYPECONFIGRATION_H

#include <QPushButton>
#include <QStandardItemModel>
#include <QTableView>
#include <QTreeView>
#include <QWidget>
#include "mapcore.h"
#include "dataprototype.h"

class DataConfigration : public QWidget
{
    Q_OBJECT
public:
    explicit DataConfigration(MapCore &core, std::shared_ptr<const DownAccess> target, QWidget *parent = nullptr);

private:
    MapCore &core_bind;
    std::shared_ptr<const DownAccess> target_bind;
    QTableView *const member_present;
    QStandardItemModel *const member_model;
    QTreeView *const preview_present;
    QStandardItemModel *const preview_model;
    
    QPushButton *const append, *const remove;
    
    void present_member(std::shared_ptr<const DownAccess> base);
    void present_struct(std::shared_ptr<const DownAccess> base, QStandardItem *target = nullptr);
};

#endif // DATATYPECONFIGRATION_H
